#define random(x) fract(sin(dot(x, vec2(12.9898, 4.1414))) * 43758.5453)

#define fLengthSource(x) sqrt(dotX(x))
#define fInverseLengthSource(x) inversesqrt(dotX(x))
#define fNormalizeSource(x) x * fInverseLengthSource(x)
#define fExpSource(x) exp2(x * rcpln2)
#define dotXSource(x) dot(x, x)

#define RCP(x) (1.0 / (x))
#define fPow(x, y) exp2(log2((x)) * (y))

#define dotN(x, y) dot(fNormalize(x), fNormalize(y))
#define reflectN(x, y) reflect(fNormalize(x), fNormalize(y))

#define fSign(a) (clamp01((a) * 1e35) * 2.0 - 1.0)
#define fDistance(x, y) fLengthSource(x - y)
#define fDistanceRCP(x, y) fInverseLengthSource(x - y)

#define gammaLinear(x) sqrt(x)
#define gammaNonLinear(x) x * x

#define clamp01(x) clamp(x, 0, 1)

#define min0(x) max(x, 0.0)
#define min1(x) max(x, 1.0)
#define max1(x) min(x, 1.0)
#define max0(x) min(x, 0.0)

#define io inout

#define c(type) const type
#define flat(type) flat varying type

#define pixelData0 gl_FragData[0]
#define pixelData1 gl_FragData[1]
#define pixelColor gl_FragColor

#define time frameTimeCounter
#define shadowPixels shadowMapResolution

#define underWater (isEyeInWater == 1)
#define underLava (isEyeInWater == 2)

#extension GL_EXT_gpu_shader4 : enable
#extension GL_ARB_shader_texture_lod : enable

#define textureLoad(x, y) texture2DLod(x, y, 0)
#define textureLoadLOD(x, y, z) texture2DLod(x, y, z) 

#define shadowLoad(x, y) shadow2DLod(x, y, 0)
#define shadowLoadLOD(x, y, z) shadow2DLod(x, y, z) 

#define sampleRCPVar(samples) c(float) sampleRCP = RCP(samples)

#define luma(x) dot(x, lumaCoeff)
#define saturate(x, y, z) (((x - z) * y) + z)
#define lumLerp(x, y, z) mix(x, z * (x + y), 1 - x)

#define upScale(x, y, z) ((x + z) / y)
#define downScale(x, y, z) (x * y - z)

#define transMAD(mat, v) (mat3(mat) * (v) + (mat)[3].xyz)

#define diagonal2(mat) vec2((mat)[0].x, (mat)[1].y)
#define diagonal3(mat) vec3(diagonal2(mat), (mat)[2].z)
#define diagonal4(mat) vec4(diagonal3(mat), (mat)[2].w)

#define projMAD3(mat, v) (diagonal3(mat) * (v) + (mat)[3].xyz )
#define projMAD4(mat, v) (diagonal4(mat) * (v) + (mat)[3].xyzw)

#define warmSource      (IDs == 10.0  || IDs == 11.0  || IDs == 50.0  || IDs == 51.0  || IDs == 62.0  || IDs == 90.0 || IDs == 213.0 || IDs == 327.0 )
#define emissiveSource  (IDs == 10.0  || IDs == 11.0  || IDs == 50.0  || IDs == 51.0  || IDs == 76.0  || IDs == 89.0  || IDs == 90.0 || IDs == 91.0  || IDs == 124.0 || IDs == 138.0 || IDs == 169.0 || IDs == 213.0 || IDs == 327.0 )
#define plantSource     (IDs == 161.0 || IDs == 175.0 || IDs == 141.0 || IDs == 142.0 || IDs == 115.0 || IDs == 105.0 || IDs == 106.0 || IDs == 104.0 ||IDs == 83.0   || IDs == 59.0  || IDs == 51.0  || IDs == 40.0 || IDs == 39.0 || IDs == 38.0 || IDs == 37.0	|| IDs == 31.0 || IDs == 32.0 || IDs == 30.0 || IDs == 6.0 || IDs == 18.0)
#define iceSource       (IDs == 79.0  || IDs == 174.0)
#define waterSource     (IDs == 9.0   || IDs == 8.0)
#define glassSource     (IDs == 95.0  )

#define colored  (IDs == 79.0  || IDs == 90.0  || IDs == 95.0  || IDs == 160.0 || IDs == 165.0 )

#define land     (IDs >  0.0)
#define plant    (IDs == 2.0)
#define emissive (IDs == 3.0 || IDs == 4.0)
#define warm     (IDs == 4.0)
#define water    (IDs == 5.0)
#define ice      (IDs == 6.0)
#define glass    (IDs == 7.0)