void computeIllumination(io vec3 SB, in vec3 normal, in positionStruct Position) {

	c(float) bounceSize = shadowPixelsSize * 64;

    sampleRCPVar(SUNLIGHT_BOUNCE_SAMPLES);

	vec3 shadowNormal = mat3(shadowModelView) * (mat3(gbufferModelViewInverse) * normal);

	vec3 reflectedDirection = bounceSize * (transMAD(shadowProjMatrix, lightPosition[1]) * 0.5 + 0.5) * vec3(2.0, 4.0, 1.0);

	float maxLOD = computeMaxLOD(log2(vec2(shadowPixels))) * 0.5;

	float ditherScale = dither64 * sampleRCP;

		for (int i = 0; i < SUNLIGHT_BOUNCE_SAMPLES; ++i) {

			vec2 sampleOffset = hammersleyPointMap(i, sampleRCP * i + 1.0, ditherScale) * bounceSize + reflectedDirection.xy;

			if (dot(shadowNormal.xy, sampleOffset) <= 0.0) continue;

			vec3 offsetCoord = Position.shadowSpacePosition + vec3(sampleOffset, 0.0);

		    offsetCoord.z = shadowLoadLOD(shadowtex1, offsetCoord, maxLOD).r;

			vec3 sampleDirection = offsetCoord - Position.shadowSpacePosition;

			float sampleDistance = dotX(sampleDirection);

			vec3 sampleNormal = vec3(textureLoadLOD(shadowcolor1, offsetCoord.xy, maxLOD).xy * 2.0 - 1.0, 0.0);

			sampleNormal.z = sqrt(1.0 - dotX(sampleNormal.xy));

			if (sampleDistance >= 0.03125 / sampleDirection.z * 8) continue;

			float weight = dot(sampleDirection, shadowNormal) * dot(sampleDirection, -sampleNormal) * sampleNormal.z / (sampleDistance * sampleDirection.z + sampleRCP * 0.5);

			if (weight <= 0.0) continue;

			SB = shadowLoadLOD(shadowcolor0, offsetCoord, maxLOD).rgb * clamp01(weight) + SB;

		}

	SB *= sampleRCP;

	SB *= 1.0 - timeNight;

}