void TAACompute(io vec3 output0, io vec2 newCoord) {
	
	vec3 screenPos = vec3(texCoord, 1.0);

	for (int i = -1; i <= 1; ++i) 
		for (int j = -1; j <= 1; ++j) {
			vec2 coord = ivec2(i, j) * screenPixelsSize + texCoord;
			vec3 offset = vec3(coord, textureLoad(depthtex1, coord).r);

			screenPos = offset.z < screenPos.z ? offset : screenPos;
		}

    vec4 velocity = vec4(0.0);

	velocity.xy = computeCameraVelocity(screenPos);

	velocity.zw = velocity.xy;

	#ifdef MOTIONBLUR
		c(float) shutterRCP = 1.0 / (SHUTTER_SPEED);
		c(float) shutterRCPHalf = 0.5 / (SHUTTER_SPEED);

		velocity.xy = clamp01(velocity.xy + 0.5) * shutterRCP - shutterRCPHalf;
		
		velocity.xy /= frameTime;

		velocity.xy *= 2.0 * dither01 - 0.5;
	#else
		velocity.xy = vec2(0.0);
	#endif

	vec2 prevCoord = -velocity.zw + texCoord + velocity.xy;

	if (textureLoad(colortex0, newCoord).a != 1) velocity.xy = vec2(0.0);

	newCoord = newCoord + velocity.xy;

	if (textureLoad(colortex0, newCoord).a != 1) newCoord = newCoord - velocity.xy;

	output0 = textureLoad(colortex0, newCoord).rgb;

    float weight = coordInTile(prevCoord) ? dot(0.5 - abs(fract(prevCoord * screenPixels) - 0.5), vec2(1.0)) : 0.0;

	mat2x3 limits = mat2x3(output0 * SHUTTER_SPEED, output0 / SHUTTER_SPEED);

	for (int i = -1; i <= 1; ++i)
		for (int j = -1; j <= 1; ++j) {

			vec3 colorSample = textureLoad(colortex0, ivec2(i, j) * screenPixelsSize + newCoord).rgb;

			output0 = (output0 - colorSample) * 0.125 + output0;

			limits[0] = min(colorSample, limits[0]);
			limits[1] = max(colorSample, limits[1]);

		}
    
	output0 = mix(output0, clamp(textureLoad(colortex3, prevCoord).rgb, limits[0], limits[1]), sqrt(weight) * 0.75 + inversesqrt(weight * 6.75 + 13.5));


}