void computeMotionBlur(io vec3 output0) {

    float shutterRCP = 1.0 / (SHUTTER_SPEED);
    float shutterRCPHalf = 0.5 / (SHUTTER_SPEED);

    vec2 velocity = clamp01(computeCameraVelocity(vec3(texCoord, textureLoad(depthtex1, texCoord).r)) + 0.5) * shutterRCP - shutterRCPHalf;
    
    int colorCorrect = 0;

    int sampleCount = int(clamp(fLength(abs(velocity) * screenPixels) * 4, 2, 4));

    float sampleRCP = RCP(sampleCount);

    float ditherScale = dither01 * sampleRCP;
    float direction = 2.0 * ditherScale - 0.5;

    velocity /= frameTime;

    output0 = vec3(0.0);

    for (int i = 0; i < sampleCount; ++i) { 

        vec2 coord = velocity * (i * sampleRCP + direction) + texCoord;

        if (textureLoad(colortex1, coord).a != 1) continue;

        output0 = textureLoad(colortex1, coord).rgb + output0;

        ++colorCorrect;

    }

    output0 /= colorCorrect;

}