c(float) waveSharpness = 1.8;
c(float) waveDensity = 0.4;

c(float) stepIntensity = 0.75;
c(float) weightIntensity = 2.0;
c(float) sharpnessIntensity = 0.1;
c(float) waveIntensity = 1.2;

c(vec2) sharpness = vec2(waveSharpness * waveDensity, waveDensity / waveSharpness);

float getWaves(in vec3 worldSpacePosition) {

    float waterWaves = 0.0;

    float detailSharpness = 0.9;
    float detailWeight = 3.5;
    float detailStep = 2.5;

    float rotationDegrees = pi * 0.085 + 210.0;

    vec2 movement = vec2(time * 0.58, -time * 0.43);

    for (int i = 0; i < 2; ++i) {

        if ((i & 0x00000001) > 0)

        rotationDegrees = -(rotationDegrees * (i % 3) + rotationDegrees);

        else

        movement = -movement;

        vec2 rotatedRefractCoord = rotateVector(worldSpacePosition.xz, rotationDegrees) * sharpness;
        
        waterWaves = generate2DNoise(rotatedRefractCoord - movement) * waveIntensity + waterWaves;

        vec2 detailRefractCoord = (rotatedRefractCoord - movement) * vec2(detailSharpness * detailStep, detailStep / detailSharpness);

        waterWaves = generate2DNoise(detailRefractCoord) * (waveIntensity / detailWeight) + waterWaves;

        detailStep = detailStep * stepIntensity + detailStep;
        detailWeight = detailWeight * weightIntensity + detailWeight;
        detailSharpness = detailSharpness * sharpnessIntensity + detailSharpness;

        detailRefractCoord = rotatedRefractCoord;

    }

    return clamp01(waterWaves / 32.0);
}